﻿Type=Class
Version=4.3
ModulesStructureVersion=1
B4A=true
@EndOfDesignText@
'Class module Seekbar2
#Event: ValueChanged(Value As Int)
'#RaisesSynchronousEvents: lblItem_Click

Sub Class_Globals
	Private Callback As Object			' calling module
	Private cEventName As String
	Private cActivity As Activity
	Private cParent As Panel
	Private skbPanelBack, skbPanelFront As Panel
	Private cvsPanelBack, cvsPanelFront As Canvas
	Private cdw As ColorDrawable
	Private rectPanelFront As Rect
	Private cBackLineColor = Colors.Black As Int
	Private cFrontLineColor = Colors.RGB(51, 181, 229) As Int
	Private cLimitLineColor = Colors.RGB(255, 0, 0) As Int
	Private BackgroundColor As Int
	Private CircleColor = Colors.ARGB(150, 51, 181, 229) As Int
	Private RhombusColor = Colors.ARGB(190, 51, 181, 229) As Int
	Private LoadSpeakerColor = Colors.ARGB(120, 51, 181, 229) As Int
	
	Private MarginLeft, BaseLineY, MarginRight, CircleRadius, SmallCircleRadius As Float
	Private MaxVal = 100 As Int
	Private Scale As Float
	Private cPosition As Int
	Private cLeft, cTop, cWidth, cHeight, cRadius As Int
	Private cLeftLimit, cRightLimit As Int
	Public PositionPixel As Int
	Private PositionPixels(2) As Int
	Private ShapeNb = 3 As Int
	Private cShape As Int
		' 0 = circle
		' 1 = line
		' 2 = rhombus 
		' 3 = loadspeaker
	Private SliderPath As Path
End Sub

'Initializes the object. You can add parameters to this method if needed.
'CallbackModule = calling module
'EventName = generic event name
'Public Sub Initialize(CallbackModule As Object, EventName As String, Shape As Int, TooltipLabel As Label, ToolTipText As String)
Public Sub Initialize(CallbackModule As Object, EventName As String)
	Callback = CallbackModule
	cEventName = EventName
End Sub

'This routine is used by the Designer if you add the ComboBox in the Designer
Public Sub DesignerCreateView(Base As Panel, lbl As Label, Props As Map)
	skbPanelBack = Base
	cLeft = Base.Left
	cTop = Base.Top
	cWidth = Base.Width
	cHeight = Base.Height

	cActivity = Props.Get("activity")
	
'	GetParent2(Base)
	
	Init
End Sub

'This routine is needed if you want to add the ComboBox view in the code.
'Parent = parent view, can be a Panel or the Activity
'Left, Top, Width and Height properties of the ComboBox
'Color = background color
'Radius = corner radius
'Shape 0 = circle, 1 = line, 2 = rhombus, 3 = loadspeaker
'ToolTopLabel = label to display the tooltip
'ToolTipText = tooltip text to display
'Example: 
'<Code>SeekBar1.Initialize(Me, "SeekBar1")
'ComboBox1.Show(Activity, 20dip, 20dip, 150dip, 48dip, Colors.DarkBlue, 5dip, 3, lblToolTip, "Adjust volume")</Code>
Public Sub AddToParent(Parent As Panel, Left As Int, Top As Int, Width As Int, Height As Int, Color As Int, Radius As Int, Shape As Int)
 	cLeft = Left
	cTop = Top
	cWidth = Width
	cHeight = Height
	cHeight = Max(cHeight, 20dip)
	cParent = Parent
	BackgroundColor = Color
	
	cShape = Min(Shape, ShapeNb)
	cShape = Max(cShape, 0)

	cRadius = Min(Radius, Height / 2 - 2dip)
	skbPanelBack.Initialize("")
	cParent.AddView(skbPanelBack, cLeft, cTop, cWidth, cHeight)
	cdw.Initialize(Color, cRadius)
	skbPanelBack.Background = cdw
	
	Init
End Sub

'Set the properties below
'Shape 0 = circle, 1 = line, 2 = rhombus, 3 = loadspeaker
'ToolTopLabel = label to display the tooltip
'ToolTipText = tooltip text to display
Public Sub SetProperties(Shape As Int, TooltipLabel As Label, ToolTipText As String)
	cShape = Min(Shape, ShapeNb)
	cShape = Max(cShape, 0)
	DrawPos(PositionPixel, 0)	
End Sub

'Initializes the object.
Private Sub Init
	skbPanelFront.Initialize("skbPanelFront")
	skbPanelBack.AddView(skbPanelFront, 0, 0, cWidth, cHeight)
	rectPanelFront.Initialize(0, 0, skbPanelFront.Width, skbPanelFront.Height)
	skbPanelFront.BringToFront	
	
	MarginLeft = cHeight / 2
	MarginRight = skbPanelBack.Width - MarginLeft
	BaseLineY = cHeight / 2
	CircleRadius = BaseLineY - DipToCurrent(cHeight / 30)
	SmallCircleRadius = DipToCurrent(cHeight / 20)
	
	setMax(100)
	
	PositionPixels(0) = MarginLeft
	PositionPixels(1) = MarginRight
	cvsPanelBack.Initialize(skbPanelBack)
	cvsPanelBack.DrawLine(MarginLeft, BaseLineY, MarginRight, BaseLineY, cBackLineColor, 2)
	skbPanelBack.Invalidate
	
	cvsPanelFront.Initialize(skbPanelFront)
	PositionPixel = PositionPixels(0)
	DrawPos(PositionPixel, 0)	
End Sub

'sets or gets the max value
Public Sub setMax(cMax As Int)
	MaxVal = cMax
	Scale = (MarginRight - MarginLeft) / MaxVal
End Sub

Public Sub getMax As Int
	Return MaxVal
End Sub

Public Sub SetLimits(LeftLimit As Int, RightLimit As Int)
	cLeftLimit = LeftLimit
	cRightLimit = RightLimit
	
	PositionPixels(0) = LeftLimit * Scale + MarginLeft
	PositionPixels(1) = RightLimit * Scale + MarginLeft
	If PositionPixel < PositionPixels(0) Then
		cPosition = cLeftLimit
		PositionPixel = PositionPixels(0)
	Else If PositionPixel > PositionPixels(1) Then
		cPosition = cRightLimit
		PositionPixel = PositionPixels(1)
	Else
	End If
	
	skbPanelBack.Background = cdw
	cvsPanelBack.Initialize(skbPanelBack)
	cvsPanelBack.DrawLine(MarginLeft, BaseLineY, PositionPixels(0), BaseLineY, cLimitLineColor, 3dip)
	cvsPanelBack.DrawLine(PositionPixels(0), BaseLineY, PositionPixels(1), BaseLineY, cBackLineColor, 2dip)
	cvsPanelBack.DrawLine(PositionPixels(1), BaseLineY, MarginRight, BaseLineY, cLimitLineColor, 3dip)
	skbPanelBack.Invalidate

	DrawPos(MarginLeft + cPosition * Scale, 0)	
End Sub

'Sets or gets the position 
Public Sub setPosition(Pos As Float)
	cPosition = Max(cLeftLimit, Pos)
	cPosition = Min(cRightLimit, Pos)
	PositionPixel = MarginLeft + Pos * Scale
	If skbPanelFront.IsInitialized Then
		DrawPos(MarginLeft + Pos * Scale, 0)	
	End If
End Sub

Public Sub getPosition As Float
	Return cPosition
End Sub

Private Sub skbPanelFront_Touch (Action As Int, X As Float, Y As Float)
	X = Max(PositionPixels(0), X)
	X = Min(PositionPixels(1), X)
	Select Action
	Case 0  'DOWN
		DrawPos(X, 1)
	Case 2	' MOVE
		DrawPos(X, 1)
	Case 1	' UP
		DrawPos(X, 0)
	End Select
	cPosition = Floor((X - MarginLeft) / Scale + .5)
	If SubExists(Callback, cEventName & "_ValueChanged") Then
		CallSub2(Callback, cEventName & "_ValueChanged", cPosition)
	End If
End Sub

Private Sub DrawPos(x As Int, Mode As Int)
	Dim Stroke As Float

	cvsPanelFront.DrawRect(rectPanelFront, Colors.Transparent, True, 1)
	
	PositionPixel = x
	Select cShape
	Case 0	' circle
		cvsPanelFront.DrawCircle(PositionPixel, BaseLineY, SmallCircleRadius, cFrontLineColor, True, 1)
		cvsPanelFront.DrawCircle(PositionPixel, BaseLineY, CircleRadius, CircleColor, True, 1)
	Case 1	' line
		cvsPanelFront.DrawCircle(PositionPixel, BaseLineY, SmallCircleRadius, cFrontLineColor, True, 1)
		cvsPanelFront.DrawLine(PositionPixel, BaseLineY - CircleRadius, PositionPixel, BaseLineY + CircleRadius, cFrontLineColor, 2dip)
	Case 2	' rhombus
		cvsPanelFront.DrawCircle(PositionPixel, BaseLineY, SmallCircleRadius, cFrontLineColor, True, 1)
		SliderPath.Initialize(PositionPixel, BaseLineY - CircleRadius)
		SliderPath.LineTo(PositionPixel + 6dip, BaseLineY)
		SliderPath.LineTo(PositionPixel, BaseLineY + CircleRadius)
		SliderPath.LineTo(PositionPixel - 6dip, BaseLineY)
		SliderPath.LineTo(PositionPixel, BaseLineY - CircleRadius)
		cvsPanelFront.DrawPath(SliderPath, RhombusColor, True, 1)
	Case 3	' loadspeaker
		SliderPath.Initialize(PositionPixel, BaseLineY - CircleRadius / 2)
		SliderPath.LineTo(PositionPixel + CircleRadius / 2, BaseLineY - CircleRadius)
		SliderPath.LineTo(PositionPixel + CircleRadius / 2, BaseLineY + CircleRadius)
		SliderPath.LineTo(PositionPixel, BaseLineY + CircleRadius / 2)
		SliderPath.LineTo(PositionPixel - CircleRadius / 2, BaseLineY + CircleRadius / 2)
		SliderPath.LineTo(PositionPixel - CircleRadius / 2, BaseLineY - CircleRadius / 2)
		SliderPath.LineTo(PositionPixel, BaseLineY - CircleRadius / 2)
		Stroke = Ceil(1dip)
		cvsPanelFront.DrawPath(SliderPath, LoadSpeakerColor, True, 1dip)
		cvsPanelFront.DrawPath(SliderPath, cFrontLineColor, False, Stroke)
		cvsPanelFront.DrawLine(PositionPixel, BaseLineY - CircleRadius / 2, PositionPixel, BaseLineY + CircleRadius / 2, cFrontLineColor, Stroke)
	End Select
	
	cvsPanelFront.DrawLine(PositionPixels(0), BaseLineY, PositionPixel, BaseLineY, cFrontLineColor, 3dip)
	If Mode = 1 Then
		Select cShape
		Case 0	' circle
			cvsPanelFront.DrawCircle(PositionPixel, BaseLineY, CircleRadius, cFrontLineColor, False, 2)
		Case 1' line
			Dim rec As Rect
			rec.Initialize(PositionPixel - 5dip, BaseLineY - CircleRadius, PositionPixel + 5dip, BaseLineY + CircleRadius)
			cvsPanelFront.DrawRect(rec, BackgroundColor, True, 1)
			cvsPanelFront.DrawCircle(PositionPixel, BaseLineY, 4dip, cFrontLineColor, True, 1)
			cvsPanelFront.DrawRect(rec, CircleColor, True, 1)
			cvsPanelFront.DrawRect(rec, cFrontLineColor, False, 2dip)
		Case 2	' rhombus
			SliderPath.Initialize(PositionPixel, BaseLineY - CircleRadius)
			SliderPath.LineTo(PositionPixel + 6dip, BaseLineY)
			SliderPath.LineTo(PositionPixel, BaseLineY + CircleRadius)
			SliderPath.LineTo(PositionPixel - 6dip, BaseLineY)
			SliderPath.LineTo(PositionPixel, BaseLineY - CircleRadius)
			cvsPanelFront.DrawPath(SliderPath, RhombusColor, True, 1)
			cvsPanelFront.DrawPath(SliderPath, cFrontLineColor, False, 2dip)
		Case 3	' loadspeaker
			SliderPath.Initialize(PositionPixel, BaseLineY - CircleRadius / 2)
			SliderPath.LineTo(PositionPixel + CircleRadius / 2, BaseLineY - CircleRadius)
			SliderPath.LineTo(PositionPixel + CircleRadius / 2, BaseLineY + CircleRadius)
			SliderPath.LineTo(PositionPixel, BaseLineY + CircleRadius / 2)
			SliderPath.LineTo(PositionPixel - CircleRadius / 2, BaseLineY + CircleRadius / 2)
			SliderPath.LineTo(PositionPixel - CircleRadius / 2, BaseLineY - CircleRadius / 2)
			SliderPath.LineTo(PositionPixel, BaseLineY - CircleRadius / 2)
			Stroke = Ceil(1dip)
			cvsPanelFront.DrawPath(SliderPath, cFrontLineColor, True, 1)
			cvsPanelFront.DrawPath(SliderPath, RhombusColor, False, Stroke)
			cvsPanelFront.DrawLine(PositionPixel, BaseLineY - CircleRadius / 2 + 1dip, PositionPixel, BaseLineY + CircleRadius / 2 - 1dip, Colors.Transparent, Stroke)
		End Select
	End If
	skbPanelFront.Invalidate
End Sub

'Gets or sets the Visible property
Public Sub setVisible(Visible As Boolean)
	skbPanelBack.Visible = Visible
End Sub

Public Sub getVisible As Boolean
	Return skbPanelBack.Visible
End Sub

Private Sub GetParent2(v As View)
	Dim Parent As View
	
	Dim jobj = v As JavaObject

	Parent = jobj.RunMethod("getParent", Null)
	If Parent Is Panel Then
		cParent = Parent
	Else
		cParent = cActivity
	End If
End Sub

'sets or gets the Left property
Public Sub setLeft(Left As Int)
	cLeft = Left
	skbPanelBack.Left = cLeft
End Sub

Public Sub getLeft As Int
	Return cLeft
End Sub

'sets or gets the Top property
Public Sub setTop(Top As Int)
	cTop = Top
	skbPanelBack.Top = cTop
End Sub

Public Sub getTop As Int
	Return cTop
End Sub

'sets or gets the Width property
Public Sub setWidth(Width As Int)
	cWidth = Width
	skbPanelBack.Width = cWidth
	skbPanelFront.Width = cWidth
	DrawPos(PositionPixel, 0)
End Sub

Public Sub getWidth As Int
	Return cWidth
End Sub

'sets or gets the Height property
Public Sub setHeight(Height As Int)
	cHeight = Height
	skbPanelBack.Height = cHeight
	skbPanelFront.Height = cHeight

	MarginLeft = cHeight / 2
	MarginRight = skbPanelBack.Width - MarginLeft
	BaseLineY = cHeight / 2
	CircleRadius = BaseLineY - 2dip
	SmallCircleRadius = 4dip

	DrawPos(PositionPixel, 0)
End Sub

Public Sub getHeight As Int
	Return cHeight
End Sub

'sets or gets the Shape property
'Shape 0 = circle, 1 = line, 2 = rhombus, 3 = loadspeaker
Public Sub setShape(Shape As Int)
	cShape = Shape
	cShape = Min(Shape, ShapeNb)
	cShape = Max(cShape, 0)
	DrawPos(PositionPixel, 0)
End Sub

Public Sub getShape As Int
	Return cShape
End Sub

'sets or gets the back line color
Public Sub setBackLineColor(BackLineColor As Int)
	cBackLineColor = BackLineColor
	DrawPos(PositionPixel, 0)
End Sub

Public Sub getBackLineColor As Int
	Return cBackLineColor
End Sub

'sets or gets the front line color
Public Sub setFrontLineColor(FrontLineColor As Int)
	cFrontLineColor = FrontLineColor
	DrawPos(PositionPixel, 0)
End Sub

Public Sub getFrontLineColor As Int
	Return cFrontLineColor
End Sub

'sets or gets the limit line color
Public Sub setLimitLineColor(LimitLineColor As Int)
	cLimitLineColor = LimitLineColor
	DrawPos(PositionPixel, 0)
End Sub

Public Sub getLimitLineColor As Int
	Return cLimitLineColor
End Sub

